<template>
  <div v-show="filter_visible" class="alert alert-info alert-dismissible mt-1" role="alert">
    <i18n-t v-show="pre_language !== null" keypath="prefilterinfo.text" tag="span" class="pe-1" scope="global">
      <template #language>
        {{ lang_code_detailed(pre_language) }}
      </template>
    </i18n-t>
    <i18n-t v-if="pre_subject !== null" keypath="prefilterinfo.subject_text" tag="span" scope="global">
      <template #subject>
        {{ pre_subject.term }}
      </template>
    </i18n-t>
    <button type="button" @click="close" class="btn-close" aria-label="Close"></button>
  </div>
</template>

<script>
import helper from '../helper'

export default {
  name: 'PreFilterInfo',
  mixins: [helper],
  data () {
    return {
      changed: false
    }
  },
  computed: {
    pre_language () {
      return this.$store.state.pre_language
    },
    pre_subject () {
      return this.$store.state.pre_subject
    },
    filter_language () {
      return this.$store.state.filters.language
    },
    filter_subject () {
      return this.$store.state.filters.subject
    },
    filter_visible () {
      // show if pre_language defined and user has not dismissed or changed anything
      return !this.changed && this.$store.state.state === 'RESULTS' && (this.pre_language !== null || this.pre_subject !== null)
    }
  },
  methods: {
    close () {
      this.changed = true
    }
  },
  watch: {
    filter_language (newValue) {
      // hide if prefilter box was visible and user changes language filters
      this.changed = true
    },
    filter_subject () {
      this.changed = true
    }
  }
}
</script>
